map $ssl_server_name $ssl_certificate_domain  {
  default $ssl_server_name;
  "" {{ sutty }};
}

server {
  server_name _;

  access_log syslog:server=unix:/tmp/access_log.socket,nohostname access_logd;

{% if inventory_hostname in groups.sutty_certbot %}
  include snippets/acme.conf;
{% else %}
  # Redirect to "Central Validation Server"
  location ^~ /.well-known/acme-challenge/ {
    return 301 http://certbot.{{ sutty }}$request_uri;
  }
{% endif %}

  listen 80 default_server;
  listen 443 ssl default_server;
  http2 on;

  add_header Cache-Control no-cache;
  add_header Strict-Transport-Security "max-age=31536000; includeSubDomains; preload";
  add_header X-Frame-Options "sameorigin";
  add_header X-XSS-Protection "1; mode=block";
  add_header X-Content-Type-Options "nosniff";
  add_header Referrer-Policy "strict-origin-when-cross-origin";
  add_header Access-Control-Allow-Origin "*";
  # TODO: Remove panel from media-src
  add_header Content-Security-Policy-Report-Only "default-src 'self'; media-src 'self' {{ panel_env_panel_url }}; style-src 'self' 'unsafe-inline'; script-src https: 'self'; font-src data: 'self'; img-src https: 'self'; object-src 'none'; frame-src https: 'self'; connect-src 'self' https://*.{{ sutty }}; report-uri {{ panel_env_api_url }}/v1/csp_reports.json";
  add_header Permissions-Policy "interest-cohort=()";

  ssl_certificate /etc/letsencrypt/live/$ssl_certificate_domain/fullchain.pem;
  ssl_certificate_key /etc/letsencrypt/live/$ssl_certificate_domain/privkey.pem;
  ssl_session_timeout 1d;
  ssl_session_cache shared:SSL:10m;
  ssl_session_tickets off;
  # Basado en https://ssl-config.mozilla.org/#server=nginx&version=1.22.1&config=intermediate&openssl=3.0.10&guideline=5.7
  ssl_protocols TLSv1.2 TLSv1.3;
  ssl_ciphers ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES256-GCM-SHA384:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-CHACHA20-POLY1305:ECDHE-RSA-CHACHA20-POLY1305:DHE-RSA-AES128-GCM-SHA256:DHE-RSA-AES256-GCM-SHA384:DHE-RSA-CHACHA20-POLY1305;
  ssl_early_data on;

  if ($redirect_to_https) {
    return 301 https://$http_host$request_uri;
  }

  brotli_static on;
  gzip_static on;

  # Load site from the deployment directory
  root /srv/http/$http_host;

  # When 404, redirect to the 404.html page on the website
  error_page 404 =404 @404;

  # If it doesn't exist, redirect to Sutty's 404
  location @404 {
    try_files /default/404.html @404_site_not_found;
  }

  # The site doesn't exist!
  location @404_site_not_found {
    root /srv/http/{{ sutty }}/default;
    try_files /404_site_not_found.html =404;
  }

  # For migration purposes, we check if the full uri is a file, in case
  # the previous site didn't use pretty URLs, if not, try some other
  # routes or start searching for the correct 404.html
  #
  # The default type is HTML since nginx detects content type by
  # extension
  default_type "text/html";

  # Some Fediverse endpoints don't include an extension and we'd need to
  # configure everything.  By adding index.json, we can serve these
  # endpoints as directories.
  index index.html index.json;

  # Allow certain URLs to be embedded in other sites.
  location /sandboxed/ {
    add_header X-Frame-Options "";
    try_files $request_uri $uri $uri/ =404;
  }

  location / {
    try_files $request_uri $uri $uri/ =404;

    location = /.well-known/webfinger {
      default_type "application/jrd+json";
    }

    location = /.well-known/nodeinfo {
      default_type "application/jrd+json";
    }
  }
}
